#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"

//Inicia a serial por software nos pinos 10 e 11
SoftwareSerial mySoftwareSerial(10, 11); // RX, TX

DFRobotDFPlayerMini myDFPlayer;

char buf;
int pausa = 0;
int equalizacao = 0;

//define qual caminho tomou
int caminho = 0;

//define em qual capítulo está
int capitulo = 0;

//Definicao pinos botão
int botao1 = 6;
int botao2 = 7;

//Definicao pinos sensor
int pino_analogico = A5;
int pino_analogico2 = A0;
int pino_digital = 7;
int pino_digital2 = 12;
int valor_analogico = 0;
int valor_analogico2 = 0;

//variáveis de áudio
int quantidadeTotalAudio = 11; //quantidade de áudio = Áudio inicial + 2 áudios por 5 capítulos
int capituloFinal = 6; //6 rodadas

void setup ()
{
  //Define pinos sensor como entrada
  pinMode(pino_analogico, INPUT);
  pinMode(pino_digital, INPUT);

  //Definicoes iniciais Áudio
  mySoftwareSerial.begin(9600);
  myDFPlayer.begin(mySoftwareSerial); //inicia módulo MP3, essa linha ficava dentro da Serial
  
  myDFPlayer.setTimeOut(500); //Timeout serial 500ms
  myDFPlayer.volume(80); 
  myDFPlayer.EQ(0); //Equalizacao normal
  
  pinMode(botao1, INPUT);
  pinMode(botao2, INPUT);

  Serial.begin (9600); // Serial output with 9600 bps
}
  
void loop ()
{

  //CAMINHO 1:
  //capítulo 1 - caminho 1 - toca o som 1
  //capítulo 2 - caminho 1 - toca o som 2
  //capítulo 3 - caminho 1 - toca o som 3
  //capítulo 4 - caminho 1 - toca o som 4
  //capítulo 5 - caminho 1 - toca o som 5
  
  //CAMINHO 2 (soma mais 5):
  //capítulo 1 + 5 - toca o som 5
  //capítulo 2 + 5 - toca o som 6
  //capítulo 3 + 5 - toca o som 7
  //capítulo 4 + 5 - toca o som 8  
  //capítulo 5 + 5 - toca o som 9
//----------------------------------------------------
//          Entrada pelos sensores sonoros
//----------------------------------------------------
  valor_analogico = analogRead(pino_analogico);
  //Serial.print("Saida A0: ");
  //Serial.print(valor_analogico);

  delay (500);

  //CAMINHO 1
  if (valor_analogico > 90) {

    ExecutaAudio(0, "sopro");
    
  }

  valor_analogico2 = analogRead(pino_analogico2);
  //Serial.print("Saida A02: ");
  //Serial.print(valor_analogico2);

  delay (500);
  
  //CAMINHO 2
  if (valor_analogico2 > 90) {

    ExecutaAudio(5, "sopro");
            
  }  
//----------------------------------------------------
//          Entrada pelos botões
//----------------------------------------------------
  //CAMINHO 1
  if (digitalRead(botao1) == HIGH) {

    ExecutaAudio(0, "botão");
    
  }
  
  //CAMINHO 2
  else if (digitalRead(botao2) == HIGH) {

    ExecutaAudio(5, "botão");
    
  }  

  //zerar o capítulo quando chegar a 6
  if (capitulo == capituloFinal){
    capitulo = 0;
  }
  
}

void ExecutaAudio(int audioInicial, String tipoControle){

  //se apertar qualquer botão pela primeira vez, tocar o áudio de contação de história inicial
  if (capitulo == 0){
    //toca o último áudio
    myDFPlayer.play(quantidadeTotalAudio);
    delay(5000);
  }
  else{
            
    Serial.print(tipoControle + ": ");
    Serial.print(caminho);
    Serial.print("capitulo: ");
    Serial.print(capitulo);
    
    myDFPlayer.play(capitulo + audioInicial);

    delay(3000);  
  }

  //vai adicionando 1 na variável capitulo para ir avançando as casas. Na quarta, reinicia.
  capitulo = capitulo + 1;  
  
}

